# Constants and Friends

---

### Const Functions

* Functions marked **const **are guaranteed not to modify the object's state:

```cpp
class CyberWarrior {
public:
    bool is_thirsty() const {
        return thirsty;
    }
    void beer_me() {
        thirsty = true;
    }
private:
    bool thirsty;
};
```

```cpp
void check_status(const CyberWarrior &warrior) {
    auto x = warrior.is_thirsty(); // OK!
    // warrior.beer_me();          // won't compile
}

void beer_thirsty_warrior(CyberWarrior &warrior) {
    if (warrior.is_thirsty())
        warrior.beer_me();        // Ok, warrior is not const
```

* The **is\_thirsty\(\) **function doesn't modify a CyberRanger's state, so we mark it as a **const.**

---

### BFFs

* Recall that private \(and protected\) members of a class cannot be accessed from the outside \(unless they are friends\)
* The **friend **keyword can be applied to both functions and classes to allow access to private members

```cpp
#include <iostream>

class Polygon{
protected:
    int width, height;
public:
    void set_values(int a = 0, int b = 0) {
        width = a; height = b;
    }
    friend void print_values(Polygon &poly);
    void print_values2(Polygon &poly);
    friend class Geometry;
};


// Does this one work?
void print_values(Polygon &poly) {
    printf("Width: %d Height: %d \n", poly.width, poly.height);
}

// What about this one?
void print_values2(Polygon &poly) {
    printf("Width: %d Height %d \n", poly.width, poly.height);
}

// We won't talk about this too much yet... but does it compile?
class Geometry {
    Polygon poly;
public:
    void set_values(int a = 0, int b = 0) {
        poly.width = a; poly.height = b;
    }
};

int main() {
    Polygon geo;
    geo.set_values(50, 20);
    print_values(geo);

    return 0;
}
```



